module ExtensionModelBehaviour
  extend ActiveSupport::Concern
  # It gives model additional scope active and scoped.

  included do
    scope :active, -> { where(active: true) }
    scope :scoped, -> { select(:id, scoped_attribute) }

    def self.scoped_attribute
      return :code if column_names.include? 'code'
      :name
    end
  end
end
