require 'devise'
require 'jabysoft/base/version'
require 'jabysoft/base/configuration'
require 'rails/engine'

module Jabysoft
  class << self
    attr_writer :configuration
  end

  def self.configuration
    @configuration ||= Jabysoft::Base::Configuration.new
  end

  def self.configure
    yield configuration if block_given?
  end

  module Base
    class Engine < ::Rails::Engine
      config.app_generators do |g|
        g.templates.unshift File.expand_path('../../templates', __FILE__)
        g.orm             :active_record
        g.template_engine :haml
        g.test_framework  :rspec, fixture: true
      end
    end
  end
end
